#ifndef	SPECIFICACTOR_H
#define SPECIFICACTOR_H

#ifdef	__cplusplus
extern "C" {
#endif

#include "Genesis.h"

#pragma warning( disable : 4068 )
// Define the entity for the world editor
#pragma GE_Type("Item.ico")
typedef struct SpecificActor
{
	#pragma GE_Private
	geFloat	lastTime; // Last animation played
	geActor	*	pActor; // Actual actor
	geActor_Def *	pActorDef; // Actor definition
	geFloat startTime;	// Animation start time
	geVec3d	Rotation; // Vector for rotation
	char *	MotionUna; // Motion name (una sola animacin no cclica)
	char *	MotionCic; // Motion name (una animacin cclica)
	#pragma GE_DefaultValue(MotionUna, "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
	#pragma GE_DefaultValue(MotionCic, "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
	#pragma GE_Published
	char *CommandsFile;
	geVec3d	Origin; //Origin of entity
	geVec3d	scale; // Vector for scaling
	geVec3d	Orientation; // Vector for orientation
	char	*ActorFile; // Path and file of the actor
	char *	Motion; // Motion name
	float ASpeed; // Speed of animation
	float	RSpeed; // Speed of rotation
	geBoolean	RotateX; // Will it rotate on the X axis?
	geBoolean	RotateY; // Will it rotate on the Y axis?
	geBoolean	RotateZ; // Will it rotate on the Z axis?
	geBoolean	Visible; // Visible actor 'True/False'

	#pragma GE_Origin(Origin)
	#pragma GE_DefaultValue(scale, "2.5 2.5 2.5")
	#pragma GE_DefaultValue(Orientation, "0 0 0")
	#pragma GE_DefaultValue(Rotation, "0 0 0")
	#pragma GE_DefaultValue(ActorFile, "")
	#pragma GE_DefaultValue(Motion, "Idle")
	#pragma GE_DefaultValue(ASpeed, "0.04")
	#pragma GE_DefaultValue(RSpeed, "0.03")
	#pragma GE_DefaultValue(RotateX, "False")
	#pragma GE_DefaultValue(RotateY, "False")
	#pragma GE_DefaultValue(RotateZ, "False")
	#pragma GE_DefaultValue(CommandsFile, "")
	#pragma GE_DefaultValue(Visible, "True")

	#pragma GE_Documentation(CommandsFile, "Commands file. No needed .ini extension")
	#pragma GE_Documentation(scale, "Amount to scale the actor")
	#pragma GE_Documentation(Orientation, "Orientation of the actor")
	#pragma GE_Documentation(ActorFile, "Path and file of the actor")
	#pragma GE_Documentation(Motion, "Motion name (case sensitive), leave blank for none")
	#pragma GE_Documentation(ASpeed, "Speed of the animation. 0.1 = fast, 0.01 = slow, 0.05 = medium, etc.")
	#pragma GE_Documentation(RSpeed, "Speed of the rotation. 0.1 = fast, 0.01 = slow, 0.05 = medium, etc.")
	#pragma GE_Documentation(RotateX, "Will the actor rotate on the X axis?")
	#pragma GE_Documentation(RotateY, "Will the actor rotate on the Y axis?")
	#pragma GE_Documentation(RotateZ, "Will the actor rotate on the Z axis?")
	#pragma GE_Documentation(Visible, "Visible actor?")

} SpecificActor;

// Functions
geBoolean SpecificActor_Spawn(geEngine *Engine, geWorld *World, geVFile *MainFS, geSound_System *SoundSystem);
geBoolean SpecificActor_Render(geWorld *World);

#ifdef	__cplusplus
}
#endif

#endif